/*
/// Layout
*/

:root {
  --page-margins: var(--baseline);
  --card-width-min: 10ch;
}

/* Page & Wrapper
// -------------------------
*/

#page {
  padding-bottom: var(--baseline);
  width: 100%;
}

#page,
#wrapper {
  position: relative;
  margin-right: auto;
  margin-left: auto;
}

#wrapper {
  padding-right: var(--page-margins);
  padding-left: var(--page-margins);
}

#page-header {
  --aspect-ratio: 1.91/1;
  height: 0;
  padding-top: calc(100% / (var(--aspect-ratio)));
  background-repeat: no-repeat;
  position: relative;
}
#page-header img {
  position: absolute;
  top: 0;
  right: 0;
  left: 0;
  bottom: 0;
  width: 100%;
  border-radius: 0;
  aspect-ratio: var(--aspect-ratio);
  object-fit: cover;
}

#page-header + #wrapper main header:first-of-type .page-icon {
  margin-top: -.5em;
}
@media screen and (min-width: 80rem) { /* >= 1280px */
  #page-header + #wrapper main .toc-container {
    margin-top: 2.25rem;
  }
}

/* bodyClass: contain */
body.contain #page-header {
  background-size: contain;
  background-color: white;
  background-repeat: no-repeat;
}


/* Grid
// -------------------------
*/

@supports (grid-area: auto) {
  .grid {
    display: grid;
    grid-gap: var(--baseline);
    margin: 0 0 var(--baseline);
    padding: 0 0 var(--baseline);
  }

  .grid-center {
    display: grid;
    place-items: center;
  }

  .grid-main {
    grid-template-columns: 1fr;
  }

  .grid-link {
    grid-template-columns: 1fr;
    grid-gap: 0 var(--baseline);
  }

  .grid-auto {
    grid-template-columns: repeat(auto-fit, minmax(var(--min, 240px), var(--max, 1fr)));
    grid-gap: var(--grid-gap);
  }

  .grid-3 {
    grid-template-columns: repeat(3, 1fr);
    grid-gap: var(--grid-gap);
    align-items: var(--align-items);
  }

  .grid-layout {
    --grid-gap: var(--baseline);
    grid-template-columns: 0 1fr 0;
    grid-gap: var(--grid-gap);
  }

  .grid-content {
    grid-template-columns: min(1fr, calc(100vw - var(--page-margins)*2));
    grid-template-areas:
              "header"
              "aside"
              "content";
    grid-gap: 0 var(--baseline);
  }

  .grid-content > header {
    grid-area: header;
  }

  .grid-content > aside,
  .grid-content > .aside {
    grid-area: aside;
  }

  .grid-content > .content {
    grid-area: content;
  }

  .grid-layout-header {
    grid-template-columns: 1fr 3rem 4rem;
    align-items: center;
    --grid-gap: 1rem;
  }

}

@media screen and (min-width: 30rem) { /* >= 480px */
  :root {
    --page-margins: calc(var(--baseline) * 1.5);
  }
  .grid-layout-header {
    grid-template-columns: 2fr 1fr 4rem;
  }
}

@media screen and (min-width: 64rem) { /* >= 1024px */

  :where(.grid) {
    grid-template-columns: repeat(auto-fit, minmax(var(--card-width-min), 1fr));
    grid-gap: var(--baseline);
  }

  .grid-main {
    grid-template-columns: 1fr;
  }

  .grid-layout-header {
    display: grid;
    grid-template-columns: minmax(320px,var(--width-3-column)) 1fr;
    grid-gap: 0;
  }
}

@media screen and (min-width: 80rem) { /* >= 1280px */

  .grid-main {
    grid-template-columns: var(--width-6-column) 1fr;
  }

  .grid-content {
    grid-template-columns: 2fr minmax(200px,1fr);
    grid-template-rows: auto 1fr;
    grid-template-areas:
              "header aside"
              "content aside";
    grid-gap: 0 calc(var(--baseline) * 2);
  }

  .grid-content > .aside,
  .grid-content > aside {
    position: -webkit-sticky;
    position: sticky;
    align-self: start;
    justify-self: end;
    width: 100%;
    max-width: 20rem;
    top: calc(var(--offset-page) + var(--baseline))
  }

}

@media screen and (min-width: 96rem) { /* >= 1536px */

  :root {
    --page-margins: calc(var(--baseline) * 2.25);
  }

  .grid-content {
    grid-template-columns: 3fr 2fr;
  }

}

.grid-start-end {
  grid-column-start: 2;
}


/* Flex
// -------------------------
*/

.flex {
  display: flex;
}

.flex-grid {
  display: block;
}

.flex-align {
  display: flex;
  align-items: center;
}

.flex-between {
  display: flex;
  align-items: center;
  justify-content: space-between;
}

.flex-gap > * {
  padding: calc(var(--baseline) / 2) 0;
}

.flex-wrap {
  flex-wrap: wrap;
}

@media screen and (min-width: 37.5em) {
  .flex-grid {
    display: flex;
    flex-direction: row;
  }

  .flex-gap > * {
    padding: 0 calc(var(--baseline) / 2);
  }
}

@supports (gap: 10px) {
  .flex-gap {
    gap: var(--baseline);
  }
  .flex-gap > * {
    padding: unset;
  }
}

.flex > * {
  flex: 1;
}

.flex-2 {
  flex: 2;
}

.flex-3 {
  flex: 3;
}

.flex-4 {
  flex: 4;
}

.flex-max {
  flex: 999;
}

.flex-min {
  flex: 0.001;
}

.flex-unset {
  flex: unset;
}

.flex-full {
  flex-basis: 100%;
}

.flex-column {
  -ms-flex-direction: column;
  flex-direction: column;
}


/* Alignement
// -------------------------
*/

.row-reverse {
  flex-direction: row-reverse;
}

.align-center {
  vertical-align: middle;
}

.justify-content-center {
  -ms-flex-pack: center;
  justify-content: center;
}

.justify-content-end {
  -ms-flex-pack: end;
  justify-content: flex-end;
}

/*
 * Layout
 */

.fixed {
  position: fixed;
}

.absolute {
  position: absolute;
}

.relative {
  position: relative;
}

.sticky {
  position: -webkit-sticky;
  position: sticky;
}

.left {
  float: left;
}

.right {
  float: right;
}

.inset-0 {
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
}

.inset-x-0 {
  right: 0;
  left: 0;
}

.box-border {
  box-sizing: border-box;
}

.block {
  display: block;
}

.inline-block {
  display: inline-block;
}

.inline-flex {
  display: inline-flex;
}

.table {
  display: table;
}

.grid {
  display: grid;
}

.hidden {
  display: none;
}

.flex-col {
  flex-direction: column;
}

.flex-col-reverse {
  flex-direction: column-reverse;
}

.items-center {
  align-items: center;
}

.items-baseline {
  align-items: baseline;
}

.justify-center {
  justify-content: center;
}

.justify-between {
  justify-content: space-between;
}

.flex-1 {
  flex: 1 1 0;
}

.flex-auto {
  flex: 1 1 auto;
}

.flex-grow {
  flex-grow: 1;
}

.order-first {
  order: -9999;
}


@media(min-width:40rem) {
  .sm\:flex-row {
    flex-direction: row;
  }

  .sm\:items-center {
    align-items: center;
  }
}

@media(min-width:48rem) {
  .md\:flex-row {
    flex-direction: row;
  }
}

@media(min-width:64rem) {
  .lg\:block {
    display: block;
  }

  .lg\:flex {
    display: flex;
  }

  .lg\:hidden {
    display: none;
  }

  .lg\:flex-row {
    flex-direction: row;
  }

  .lg\:justify-start {
    justify-content: flex-start;
  }

  .lg\:justify-between {
    justify-content: space-between;
  }

  .lg\:order-last {
    order: 9999;
  }

  .lg\:static {
    position: static;
  }

  .lg\:absolute {
    position: absolute;
  }

  .lg\:relative {
    position: relative;
  }

  .lg\:sticky {
    position: -webkit-sticky;
    position: sticky;
  }

  .lg\:top-0 {
    top: 0;
  }

  .lg\:right-auto {
    right: auto;
  }
}

@media(min-width:80rem) {
  .xl\:block {
    display: block;
  }

  .xl\:hidden {
    display: none;
  }

  .xl\:top-0 {
    top: 0;
  }

  .xl\:sticky {
    position: -webkit-sticky;
    position: sticky;
  }
}
